"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _chunkLHP7OTMVcjs = require('./chunk-LHP7OTMV.cjs');

// src/common/data/rounding.ts
function isHalf(value) {
  return Math.abs(value) % 1 === 0.5;
}
function isEven(value) {
  return value % 2 === 0;
}
var roundUp = (value) => Math.ceil(value);
var roundDown = (value) => Math.floor(value);
var roundHalfUp = (value) => Math.round(value);
var roundHalfOdd = (value) => {
  const rounded = Math.round(value);
  if (!isHalf(value))
    return rounded;
  return isEven(rounded) ? rounded - 1 : rounded;
};
var roundHalfAwayFromZero = (value) => {
  return isHalf(value) ? Math.sign(value) * Math.ceil(Math.abs(value)) : Math.round(value);
};
var roundHalfDown = (value) => isHalf(value) ? Math.floor(value) : Math.round(value);
var roundHalfEven = (value) => {
  const rounded = Math.round(value);
  if (!isHalf(value))
    return rounded;
  return isEven(rounded) ? rounded : rounded - 1;
};
var roundHalfTowardsZero = (value) => isHalf(value) ? Math.sign(value) * Math.floor(Math.abs(value)) : Math.round(value);
function roundArrayOfNumbersToMatchSum(ipt, max = 100, decimalPlaces = 0) {
  const iptPercents = [...ipt];
  const length = ipt.length;
  const out = [];
  out.fill(0, length);
  const total = _chunkLHP7OTMVcjs.arraySum.call(void 0, iptPercents);
  if (total !== 0) {
    const powDecimalPlaces = 10 ** decimalPlaces;
    const pow100 = max * powDecimalPlaces;
    let check100 = 0;
    for (let i = length - 1; i >= 0; i--) {
      iptPercents[i] = max * iptPercents[i] / total;
      check100 += out[i] = Math.round(iptPercents[i] * powDecimalPlaces);
    }
    if (check100 !== pow100) {
      const totalDiff = check100 - pow100;
      const roundGrain = 1;
      let grainCount = Math.abs(totalDiff);
      const diffs = iptPercents.map((_, i) => Math.abs(out[i] - iptPercents[i] * powDecimalPlaces));
      while (grainCount > 0) {
        let idx = 0;
        let maxDiff = diffs[0];
        for (let i = 1; i < length; i++) {
          if (maxDiff < diffs[i]) {
            if (check100 > pow100 && out[i] - roundGrain < 0)
              continue;
            idx = i;
            maxDiff = diffs[i];
          }
        }
        if (check100 > pow100)
          out[idx] -= roundGrain;
        else
          out[idx] += roundGrain;
        diffs[idx] -= roundGrain;
        grainCount--;
      }
    }
    if (powDecimalPlaces > 1)
      return out.map((n) => +(n / powDecimalPlaces).toFixed(decimalPlaces));
  }
  return out;
}
function roundArrayOfObjectsToMatchSum(arr, name, max = 100, decimalPlaces = 0) {
  return roundArrayOfNumbersToMatchSum(arr.map((o) => o[name]), max, decimalPlaces).map((o, i) => ({
    ...arr[i],
    [name]: o
  }));
}














exports.isHalf = isHalf; exports.isEven = isEven; exports.roundUp = roundUp; exports.roundDown = roundDown; exports.roundHalfUp = roundHalfUp; exports.roundHalfOdd = roundHalfOdd; exports.roundHalfAwayFromZero = roundHalfAwayFromZero; exports.roundHalfDown = roundHalfDown; exports.roundHalfEven = roundHalfEven; exports.roundHalfTowardsZero = roundHalfTowardsZero; exports.roundArrayOfNumbersToMatchSum = roundArrayOfNumbersToMatchSum; exports.roundArrayOfObjectsToMatchSum = roundArrayOfObjectsToMatchSum;
//# sourceMappingURL=chunk-KCBJGJ24.cjs.map