"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }

var _chunkLXSY24WIcjs = require('./chunk-LXSY24WI.cjs');


var _chunkVAG3XY63cjs = require('./chunk-VAG3XY63.cjs');


var _chunkN5KTMDVOcjs = require('./chunk-N5KTMDVO.cjs');


var _chunkLHP7OTMVcjs = require('./chunk-LHP7OTMV.cjs');

// src/common/dispose-defer.ts
function polyfillUsing() {
  try {
    _nullishCoalesce(Symbol.dispose, () => ( (Symbol.dispose = Symbol("Symbol.dispose"))));
    _nullishCoalesce(Symbol.asyncDispose, () => ( (Symbol.asyncDispose = Symbol("Symbol.asyncDispose"))));
  } catch (err) {
  }
}
function callDisposer(disposable) {
  let result;
  if (typeof disposable === "function")
    result = disposable();
  else if (_chunkN5KTMDVOcjs.isPromise.call(void 0, disposable))
    result = disposable;
  else if (typeof disposable.dispose === "function")
    result = disposable.dispose();
  else if (_chunkN5KTMDVOcjs.isPromise.call(void 0, disposable.dispose))
    result = disposable.dispose;
  if (_chunkN5KTMDVOcjs.isPromise.call(void 0, result))
    return result;
}
function useDispose(config) {
  let opt = config;
  if (opt != null) {
    if (_chunkVAG3XY63cjs.isString.call(void 0, opt))
      opt = { name: opt };
    else if ("debug" in opt && "label" in opt)
      opt = { name: opt.label, log: opt };
  }
  polyfillUsing();
  const name = _optionalChain([opt, 'optionalAccess', _ => _.name]);
  const log = _nullishCoalesce(_optionalChain([opt, 'optionalAccess', _2 => _2.log]), () => ( _chunkLXSY24WIcjs.DefaultLogger.call(void 0, "zeed:dispose")));
  let disposed = 0;
  const tracked = [];
  function untrack(disposable) {
    if (disposable != null && tracked.includes(disposable)) {
      _chunkLHP7OTMVcjs.arrayFilterInPlace.call(void 0, tracked, (el) => el !== disposable);
      const result = callDisposer(disposable);
      if (_chunkN5KTMDVOcjs.isPromise.call(void 0, result))
        return result;
    }
  }
  function track(obj) {
    if (obj == null)
      return;
    tracked.unshift(obj);
    return () => untrack(obj);
  }
  function dispose(strictSync = false) {
    if (name)
      log.debug(`dispose "${name}": ${tracked.length} entries`);
    disposed += 1;
    const promises = [];
    while (tracked.length > 0) {
      const fn = tracked[0];
      const result = untrack(fn);
      if (_chunkN5KTMDVOcjs.isPromise.call(void 0, result)) {
        if (strictSync)
          throw new Error(`Async disposable found: ${fn} -> ${result}`);
        else
          promises.push(result);
      }
    }
    if (promises.length > 0)
      return Promise.all(promises);
  }
  function disposeSync() {
    void dispose(true);
  }
  return Object.assign(dispose, {
    /** Counter that incremends, each time dispose has been called */
    disposed,
    add: track,
    remove: untrack,
    /** @deprecated use add */
    track,
    /** @deprecated use remove */
    untrack,
    dispose,
    disposeSync,
    sync: disposeSync,
    /** @deprecated use dispose */
    exec: dispose,
    getSize() {
      return tracked.length;
    },
    isDisposed() {
      return tracked.length <= 0;
    },
    [Symbol.dispose]() {
      return dispose();
    },
    async [Symbol.asyncDispose]() {
      return await dispose();
    }
  });
}
function useDefer(config = {}) {
  const { mode = "fifo" } = config;
  const steps = [];
  polyfillUsing();
  const exec = async (expectSync = false) => {
    while (steps.length > 0) {
      const step = steps[0];
      _chunkLHP7OTMVcjs.arrayFilterInPlace.call(void 0, steps, (el) => el !== step);
      if (typeof step === "function") {
        const result = step();
        if (_chunkN5KTMDVOcjs.isPromise.call(void 0, result)) {
          if (expectSync) {
            throw new Error(
              `Expected sync only function, but found async: ${step}`
            );
          }
          await result;
        }
      } else if (_chunkN5KTMDVOcjs.isPromise.call(void 0, step)) {
        if (expectSync) {
          throw new Error(
            `Expected sync only function, but found async: ${step}`
          );
        }
        await step;
      } else {
        throw new Error(`Unhandled disposable: ${step}`);
      }
    }
  };
  const add = (obj) => {
    if (mode === "lifo")
      steps.unshift(obj);
    else
      steps.push(obj);
  };
  return Object.assign(exec, {
    add,
    exec,
    getSize() {
      return steps.length;
    }
  });
}





exports.polyfillUsing = polyfillUsing; exports.useDispose = useDispose; exports.useDefer = useDefer;
//# sourceMappingURL=chunk-OOAMMLXY.cjs.map