import "../../chunk-TSCDX4AS.js";
import "../../chunk-AN7WCP7S.js";
import "../../chunk-D6B6MYVG.js";
import {
  DefaultLogger
} from "../../chunk-2DAGZ4FT.js";
import "../../chunk-3MLDC2KV.js";
import "../../chunk-7G6NITL4.js";
import "../../chunk-I45WP5PM.js";
import "../../chunk-MIZOLME5.js";
import "../../chunk-AKLYUMQO.js";
import "../../chunk-YX6CL4KH.js";
import "../../chunk-ZFRTRIT4.js";
import "../../chunk-CFICINSP.js";
import "../../chunk-3KKFLSLG.js";
import "../../chunk-PLBFBDKH.js";
import "../../chunk-2H4XRKWS.js";
import "../../chunk-WJUQ3VXF.js";
import "../../chunk-O4GTSXBN.js";
import "../../chunk-2OUSR2BE.js";
import "../../chunk-ZDZ4EQHN.js";
import "../../chunk-PZP2B3FC.js";
import "../../chunk-NSJKG6AJ.js";
import "../../chunk-XHPHUZE4.js";
import "../../chunk-NRGUBMFA.js";
import "../../chunk-H564H42Z.js";
import "../../chunk-PE4JT3J7.js";
import "../../chunk-FL5CT6MC.js";
import "../../chunk-2HWPZ6ZE.js";
import {
  deepEqual,
  deepMerge,
  deepStripUndefinedInPlace
} from "../../chunk-LAWEUL6N.js";
import "../../chunk-V5ZQ2SFQ.js";
import "../../chunk-DGP32WEQ.js";
import "../../chunk-EDNCPFSF.js";
import "../../chunk-73CVRDI7.js";
import "../../chunk-3KQS63H6.js";
import "../../chunk-C7K2ID3C.js";
import "../../chunk-L324TYGN.js";
import "../../chunk-5DS3NT57.js";
import "../../chunk-HLRQ5H3N.js";
import "../../chunk-UO7L7NBK.js";
import "../../chunk-QUQRUDWG.js";
import "../../chunk-ITJJZ6AV.js";
import "../../chunk-QUKKMPRF.js";
import "../../chunk-GY34N3KU.js";
import "../../chunk-X56GIAWQ.js";
import "../../chunk-PN34O4SN.js";
import "../../chunk-UOAPXGA4.js";
import "../../chunk-HJ22ULAI.js";
import "../../chunk-EJGW3W3K.js";
import "../../chunk-EAYWSLQT.js";
import "../../chunk-I7BWSAN6.js";

// src/common/data/deep.spec.ts
var log = DefaultLogger("test:deep");
describe("deep", () => {
  it("should deep without self reference", () => {
    const sample = {
      a: 1
    };
    sample.b = sample;
    const sample2 = {
      a: 1
    };
    sample2.b = sample2;
    log("sample", sample);
    expect(deepEqual(sample, sample2)).toBe(false);
  });
  it("should compare arays", () => {
    const a = [1, 2, 3];
    const b = [3, 2, 1];
    expect(deepEqual(a, b)).toBe(false);
    const c = [3, 2, 1, 0];
    expect(deepEqual(a, c)).toBe(false);
  });
  it("should simple checks", () => {
    const value = new String("Hello");
    expect(typeof value === "object").toBe(true);
    expect(value.valueOf()).toBe("Hello");
    expect(new String(value).valueOf()).toBe("Hello");
  });
  it("should merge deep", () => {
    const a = {
      hello: {
        world: 42
      },
      before: {
        magic: 666
      }
    };
    const b = {
      hello: {
        world: -1,
        sea: "none"
      },
      other: {
        fish: 2
      }
    };
    const c = {
      other: {
        fish: 8
      }
    };
    const d = deepMerge(a, b, c);
    expect(d).toEqual({
      hello: {
        world: -1,
        sea: "none"
      },
      other: {
        fish: 8
      },
      before: {
        magic: 666
      }
    });
  });
  it("should strip undefined", () => {
    const sample = {
      hello: {
        world: -1,
        null1: null,
        undefined1: void 0,
        sea: "none"
      },
      undefined1: void 0,
      other: [
        {
          fish: 8,
          undefined1: void 0
        },
        void 0,
        null,
        "Hello"
      ],
      before: {
        magic: 666
      }
    };
    expect(JSON.stringify(sample, null, 2)).toMatchInlineSnapshot(`
      "{
        "hello": {
          "world": -1,
          "null1": null,
          "sea": "none"
        },
        "other": [
          {
            "fish": 8
          },
          null,
          null,
          "Hello"
        ],
        "before": {
          "magic": 666
        }
      }"
    `);
    expect(deepStripUndefinedInPlace(sample)).toMatchInlineSnapshot(`
      Object {
        "before": Object {
          "magic": 666,
        },
        "hello": Object {
          "null1": null,
          "sea": "none",
          "world": -1,
        },
        "other": Array [
          Object {
            "fish": 8,
            "undefined1": undefined,
          },
          null,
          "Hello",
        ],
      }
    `);
  });
});
//# sourceMappingURL=deep.spec.js.map