"use strict";



var _chunkN7OUNPMMcjs = require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-IMCDDJAJ.cjs');

// src/common/data/format.spec.ts
describe("format.spec", () => {
  it("should format bytes in 1024 steps", async () => {
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1024.call(void 0, 123)).toMatchInlineSnapshot('"123 bytes"');
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1024.call(void 0, 16 * 1024)).toMatchInlineSnapshot('"16.00 KiB"');
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1024.call(void 0, 16 * 1024 * 1024)).toMatchInlineSnapshot('"16.00 MiB"');
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1024.call(void 0, 16 * 1024 + 123)).toMatchInlineSnapshot('"16.12 KiB"');
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1024.call(void 0, 16 * 1024 + 123, 0)).toMatchInlineSnapshot('"16 KiB"');
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1024.call(void 0, -123)).toMatchInlineSnapshot('"0 bytes"');
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1024.call(void 0, 0)).toMatchInlineSnapshot('"0 bytes"');
  });
  it("should format bytes in 1000 steps", async () => {
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1000.call(void 0, 123)).toMatchInlineSnapshot('"123 bytes"');
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1000.call(void 0, 16 * 1e3)).toMatchInlineSnapshot(`"16.00 KB"`);
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1000.call(void 0, 16 * 1024 * 1024)).toMatchInlineSnapshot(`"16.78 MB"`);
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1000.call(void 0, 16 * 1024 + 123)).toMatchInlineSnapshot(`"16.51 KB"`);
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1000.call(void 0, 16 * 1024 + 123, 0)).toMatchInlineSnapshot(`"17 KB"`);
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1000.call(void 0, -123)).toMatchInlineSnapshot('"0 bytes"');
    expect(_chunkN7OUNPMMcjs.formatBytesToHumanBase1000.call(void 0, 0)).toMatchInlineSnapshot('"0 bytes"');
  });
  it("should format time", async () => {
    expect(_chunkN7OUNPMMcjs.formatSecondsToTime.call(void 0, 0)).toMatchInlineSnapshot('"0:00"');
    expect(_chunkN7OUNPMMcjs.formatSecondsToTime.call(void 0, -123)).toMatchInlineSnapshot('"-2:03"');
    expect(_chunkN7OUNPMMcjs.formatSecondsToTime.call(void 0, 123)).toMatchInlineSnapshot('"2:03"');
    expect(_chunkN7OUNPMMcjs.formatSecondsToTime.call(void 0, 60 * 60 * 12)).toMatchInlineSnapshot('"12:00:00"');
    expect(_chunkN7OUNPMMcjs.formatSecondsToTime.call(void 0, 60 * 60 * 12, ".")).toMatchInlineSnapshot('"12.00.00"');
    expect(_chunkN7OUNPMMcjs.formatSecondsToTime.call(void 0, 60 * 60 * 1e3)).toMatchInlineSnapshot('"1000:00:00"');
  });
});
//# sourceMappingURL=format.spec.cjs.map