import { LoggerInterface, LogLevelAliasType } from './log-base.js';

/**
 * Simple log configuration for use in modular scenarios.
 *
 * `LogConfig` can be of various types:
 *
 * 1. `LoggerInterface`: Just a complete logger howeveryou like it
 * 2. `true`: The default logger on
 * 3. `string`: Logger with name
 * 4. `number`: Logger with level e.g. set to `0` to see all
 *
 * All others turn it off.
 */
type LogConfig = LoggerInterface | string | number | null | undefined | boolean;
/** See LogConfig */
declare function _LoggerFromConfig(Logger: (name?: string, level?: LogLevelAliasType) => LoggerInterface, config: LogConfig, name: string, level?: LogLevelAliasType): LoggerInterface;

export { type LogConfig, _LoggerFromConfig };
