import { LoggerContextInterface, LogLevelAliasType, LoggerInterface } from './log-base.cjs';

declare global {
    interface ZeedGlobalContext {
        logger?: any;
    }
}
/** Get or create global logger instance */
declare function getGlobalLogger(setup?: (context: LoggerContextInterface) => void): LoggerContextInterface;
/** Can be used for lazy usage e.g. inside of Zeed  */
declare function getGlobalLoggerIfExists(): any;
declare function DefaultLogger(name?: string, level?: LogLevelAliasType): LoggerInterface;

export { DefaultLogger, getGlobalLogger, getGlobalLoggerIfExists };
