interface TypeProps {
}
type Type<T = unknown> = {
    type: string;
    _optional?: boolean;
    _default?: T | (() => T);
    _object?: ObjectInput;
    _check?: (obj: any) => boolean;
    optional: () => Type<T | undefined>;
    default: (value: T | (() => T)) => Type<T | undefined>;
    parse: (obj: any, opt?: {
        transform?: boolean;
        strict?: boolean;
    }) => T;
} & TypeProps;
type Infer<T> = T extends Type<infer TT> ? TT : never;
declare function string(opt?: TypeProps): Type<string>;
declare function number(opt?: TypeProps): Type<number>;
declare function boolean(opt?: TypeProps): Type<boolean>;
type ObjectInput = Record<string, Type<any>>;
type ObjectFixOptional<T> = {
    [K in keyof T as undefined extends T[K] ? K : never]?: T[K] & {};
} & {
    [K in keyof T as undefined extends T[K] ? never : K]: T[K] & {};
};
type ObjectPretty<V> = Extract<{
    [K in keyof V]: V[K];
}, unknown>;
type ObjectOutput<T extends ObjectInput> = Type<ObjectPretty<ObjectFixOptional<{
    [K in keyof T]: Infer<T[K]>;
}>>>;
declare function object<T extends ObjectInput>(tobj: T, opt?: TypeProps): ObjectOutput<T>;

export { type Infer, boolean, number, object, string };
